# Watched Words

Manage list of watched words to detect patterns on objects (like comments of videos)

## List account watched words

`GET /api/v1/watched-words/accounts/{accountName}/lists`

**PeerTube >= 6.2**

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": []
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started


Parameters:

- `accountName` (path, string, required) - account name to list watched words
  Type: string

Responses:

- 200: successful operation

Content type: application/json

Type: any

- `total` (optional)
  Type: integer
  
  Example:
  
  ```json
  1
  ```

- `data` (optional)
  Type: Array<WatchedWordsLists>
  
  Items:
    Reference: [WatchedWordsLists](https://docs.joinpeertube.org/api-rest-reference/api/models/watchedwordslists.md); Type: WatchedWordsLists

## Examples

### cURL

```bash
curl -X GET 'https://peertube2.cpy.re/api/v1/watched-words/accounts/string/lists' \
  -H 'Authorization: Bearer YOUR_TOKEN'
```

### JavaScript

```javascript
const response = await fetch('https://peertube2.cpy.re/api/v1/watched-words/accounts/string/lists', {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
  },
});

const data = await response.text();
```

### Python

```python
import requests

response = requests.get(
    'https://peertube2.cpy.re/api/v1/watched-words/accounts/string/lists',
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
    },
)
print(response.text)
```


## Add account watched words

`POST /api/v1/watched-words/accounts/{accountName}/lists`

**PeerTube >= 6.2**

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": []
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started


Parameters:

- `accountName` (path, string, required)
  Type: string

Request body: application/json

Type: object

- `listName` (optional)
  Type: string

- `words` (optional)
  Type: Array<string>
  
  Items:
    Type: string

Responses:

- 200: successful operation

Content type: application/json

Type: object

- `watchedWordsList` (optional)
  Type: object
  
  - `id` (optional)
    Type: integer

## Examples

### cURL

```bash
curl -X POST 'https://peertube2.cpy.re/api/v1/watched-words/accounts/string/lists' \
  -H 'Authorization: Bearer YOUR_TOKEN' \
  -H 'Content-Type: application/json' \
  --data-raw '{
  "listName": "string",
  "words": [
    "string"
  ]
}'
```

### JavaScript

```javascript
const body = `{
  "listName": "string",
  "words": [
    "string"
  ]
}`;

const response = await fetch('https://peertube2.cpy.re/api/v1/watched-words/accounts/string/lists', {
  method: 'POST',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
    'Content-Type': 'application/json',
  },
  body,
});

const data = await response.text();
```

### Python

```python
import requests

body = '''{
  "listName": "string",
  "words": [
    "string"
  ]
}'''

response = requests.post(
    'https://peertube2.cpy.re/api/v1/watched-words/accounts/string/lists',
    data=body.encode('utf-8'),
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
        'Content-Type': 'application/json',
    },
)
print(response.text)
```


## Update account watched words

`PUT /api/v1/watched-words/accounts/{accountName}/lists/{listId}`

**PeerTube >= 6.2**

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": []
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started


Parameters:

- `accountName` (path, string, required)
  Type: string

- `listId` (path, string, required) - list of watched words to update
  Type: string

Request body: application/json

Type: object

- `listName` (optional)
  Type: string

- `words` (optional)
  Type: Array<string>
  
  Items:
    Type: string

Responses:

- 204: successful operation

## Examples

### cURL

```bash
curl -X PUT 'https://peertube2.cpy.re/api/v1/watched-words/accounts/string/lists/string' \
  -H 'Authorization: Bearer YOUR_TOKEN' \
  -H 'Content-Type: application/json' \
  --data-raw '{
  "listName": "string",
  "words": [
    "string"
  ]
}'
```

### JavaScript

```javascript
const body = `{
  "listName": "string",
  "words": [
    "string"
  ]
}`;

const response = await fetch('https://peertube2.cpy.re/api/v1/watched-words/accounts/string/lists/string', {
  method: 'PUT',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
    'Content-Type': 'application/json',
  },
  body,
});

const data = await response.text();
```

### Python

```python
import requests

body = '''{
  "listName": "string",
  "words": [
    "string"
  ]
}'''

response = requests.put(
    'https://peertube2.cpy.re/api/v1/watched-words/accounts/string/lists/string',
    data=body.encode('utf-8'),
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
        'Content-Type': 'application/json',
    },
)
print(response.text)
```


## Delete account watched words

`DELETE /api/v1/watched-words/accounts/{accountName}/lists/{listId}`

**PeerTube >= 6.2**

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": []
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started


Parameters:

- `accountName` (path, string, required)
  Type: string

- `listId` (path, string, required) - list of watched words to delete
  Type: string

Responses:

- 204: successful operation

## Examples

### cURL

```bash
curl -X DELETE 'https://peertube2.cpy.re/api/v1/watched-words/accounts/string/lists/string' \
  -H 'Authorization: Bearer YOUR_TOKEN'
```

### JavaScript

```javascript
const response = await fetch('https://peertube2.cpy.re/api/v1/watched-words/accounts/string/lists/string', {
  method: 'DELETE',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
  },
});

const data = await response.text();
```

### Python

```python
import requests

response = requests.delete(
    'https://peertube2.cpy.re/api/v1/watched-words/accounts/string/lists/string',
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
    },
)
print(response.text)
```


## List server watched words

`GET /api/v1/watched-words/server/lists`

**PeerTube >= 6.2**

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": [
      "admin",
      "moderator"
    ]
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started
; scopes: admin, moderator

Responses:

- 200: successful operation

Content type: application/json

Type: any

- `total` (optional)
  Type: integer
  
  Example:
  
  ```json
  1
  ```

- `data` (optional)
  Type: Array<WatchedWordsLists>
  
  Items:
    Reference: [WatchedWordsLists](https://docs.joinpeertube.org/api-rest-reference/api/models/watchedwordslists.md); Type: WatchedWordsLists

## Examples

### cURL

```bash
curl -X GET 'https://peertube2.cpy.re/api/v1/watched-words/server/lists' \
  -H 'Authorization: Bearer YOUR_TOKEN'
```

### JavaScript

```javascript
const response = await fetch('https://peertube2.cpy.re/api/v1/watched-words/server/lists', {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
  },
});

const data = await response.text();
```

### Python

```python
import requests

response = requests.get(
    'https://peertube2.cpy.re/api/v1/watched-words/server/lists',
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
    },
)
print(response.text)
```


## Add server watched words

`POST /api/v1/watched-words/server/lists`

**PeerTube >= 6.2**

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": [
      "admin",
      "moderator"
    ]
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started
; scopes: admin, moderator

Request body: application/json

Type: object

- `listName` (optional)
  Type: string

- `words` (optional)
  Type: Array<string>
  
  Items:
    Type: string

Responses:

- 200: successful operation

Content type: application/json

Type: object

- `watchedWordsList` (optional)
  Type: object
  
  - `id` (optional)
    Type: integer

## Examples

### cURL

```bash
curl -X POST 'https://peertube2.cpy.re/api/v1/watched-words/server/lists' \
  -H 'Authorization: Bearer YOUR_TOKEN' \
  -H 'Content-Type: application/json' \
  --data-raw '{
  "listName": "string",
  "words": [
    "string"
  ]
}'
```

### JavaScript

```javascript
const body = `{
  "listName": "string",
  "words": [
    "string"
  ]
}`;

const response = await fetch('https://peertube2.cpy.re/api/v1/watched-words/server/lists', {
  method: 'POST',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
    'Content-Type': 'application/json',
  },
  body,
});

const data = await response.text();
```

### Python

```python
import requests

body = '''{
  "listName": "string",
  "words": [
    "string"
  ]
}'''

response = requests.post(
    'https://peertube2.cpy.re/api/v1/watched-words/server/lists',
    data=body.encode('utf-8'),
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
        'Content-Type': 'application/json',
    },
)
print(response.text)
```


## Update server watched words

`PUT /api/v1/watched-words/server/lists/{listId}`

**PeerTube >= 6.2**

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": [
      "admin",
      "moderator"
    ]
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started
; scopes: admin, moderator

Parameters:

- `listId` (path, string, required) - list of watched words to update
  Type: string

Request body: application/json

Type: object

- `listName` (optional)
  Type: string

- `words` (optional)
  Type: Array<string>
  
  Items:
    Type: string

Responses:

- 204: successful operation

## Examples

### cURL

```bash
curl -X PUT 'https://peertube2.cpy.re/api/v1/watched-words/server/lists/string' \
  -H 'Authorization: Bearer YOUR_TOKEN' \
  -H 'Content-Type: application/json' \
  --data-raw '{
  "listName": "string",
  "words": [
    "string"
  ]
}'
```

### JavaScript

```javascript
const body = `{
  "listName": "string",
  "words": [
    "string"
  ]
}`;

const response = await fetch('https://peertube2.cpy.re/api/v1/watched-words/server/lists/string', {
  method: 'PUT',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
    'Content-Type': 'application/json',
  },
  body,
});

const data = await response.text();
```

### Python

```python
import requests

body = '''{
  "listName": "string",
  "words": [
    "string"
  ]
}'''

response = requests.put(
    'https://peertube2.cpy.re/api/v1/watched-words/server/lists/string',
    data=body.encode('utf-8'),
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
        'Content-Type': 'application/json',
    },
)
print(response.text)
```


## Delete server watched words

`DELETE /api/v1/watched-words/server/lists/{listId}`

**PeerTube >= 6.2**

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": [
      "admin",
      "moderator"
    ]
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started
; scopes: admin, moderator

Parameters:

- `listId` (path, string, required) - list of watched words to delete
  Type: string

Responses:

- 204: successful operation

## Examples

### cURL

```bash
curl -X DELETE 'https://peertube2.cpy.re/api/v1/watched-words/server/lists/string' \
  -H 'Authorization: Bearer YOUR_TOKEN'
```

### JavaScript

```javascript
const response = await fetch('https://peertube2.cpy.re/api/v1/watched-words/server/lists/string', {
  method: 'DELETE',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
  },
});

const data = await response.text();
```

### Python

```python
import requests

response = requests.delete(
    'https://peertube2.cpy.re/api/v1/watched-words/server/lists/string',
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
    },
)
print(response.text)
```


## List account watched words subscriptions

`GET /api/v1/watched-words/accounts/{accountName}/subscriptions`

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": []
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started


Parameters:

- `accountName` (path, string, required) - account name to list watched words subscriptions
  Type: string

- `start` (query, integer, optional) - Offset used to paginate results
  Type: integer
  
  minimum: 0

- `count` (query, integer, optional) - Number of items to return
  Type: integer
  
  default: 15
  
  minimum: 1
  
  maximum: 100

- `sort` (query, string, optional) - Sort column
  Type: string
  
  Example:
  
  ```json
  "-createdAt"
  ```

- `search` (query, string, optional) - Plain text search, applied to various parts of the model depending on endpoint
  Type: string

Responses:

- 200: successful operation

Content type: application/json

Type: object

- `total` (optional)
  Type: integer
  
  Example:
  
  ```json
  1
  ```

- `data` (optional)
  Type: Array<WatchedWordsSubscription>
  
  Items:
    Reference: [WatchedWordsSubscription](https://docs.joinpeertube.org/api-rest-reference/api/models/watchedwordssubscription.md); Type: WatchedWordsSubscription

## Examples

### cURL

```bash
curl -X GET 'https://peertube2.cpy.re/api/v1/watched-words/accounts/string/subscriptions?count=15' \
  -H 'Authorization: Bearer YOUR_TOKEN'
```

### JavaScript

```javascript
const response = await fetch('https://peertube2.cpy.re/api/v1/watched-words/accounts/string/subscriptions?count=15', {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
  },
});

const data = await response.text();
```

### Python

```python
import requests

response = requests.get(
    'https://peertube2.cpy.re/api/v1/watched-words/accounts/string/subscriptions?count=15',
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
    },
)
print(response.text)
```


## Add account watched words subscription

`POST /api/v1/watched-words/accounts/{accountName}/subscriptions`

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": []
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started


Parameters:

- `accountName` (path, string, required)
  Type: string

Request body: application/json

Type: object

- `url` (required)
  Type: string, url

Responses:

- 200: successful operation

Content type: application/json

Type: WatchedWordsSubscription

Schema: [WatchedWordsSubscription](https://docs.joinpeertube.org/api-rest-reference/api/models/watchedwordssubscription.md)

- `id` (optional)
  Reference: [id](https://docs.joinpeertube.org/api-rest-reference/api/models/id.md); Type: id
  
  minimum: 1
  
  Example:
  
  ```json
  42
  ```

- `name` (optional)
  Type: string

- `url` (optional)
  Type: string, url

- `importedWordsCount` (optional)
  Type: integer
  
  minimum: 0

- `lastSyncAt` (optional)
  Type: string, date-time; nullable
  
  Example:
  
  ```json
  "2021-05-04T08:01:01.502Z"
  ```

- `state` (optional)
  Type: object
  
  - `id` (optional)
    Type: integer
    
    enum: [1,2,3,4]
  
  - `label` (optional)
    Type: string

- `updatedAt` (optional)
  Type: string, date-time
  
  Example:
  
  ```json
  "2021-05-04T08:01:01.502Z"
  ```

- `createdAt` (optional)
  Type: string, date-time
  
  Example:
  
  ```json
  "2021-05-04T08:01:01.502Z"
  ```

- 400: cannot fetch or parse watched words URL

- 409: subscription already exists or watched words list with fetched name already exists

## Examples

### cURL

```bash
curl -X POST 'https://peertube2.cpy.re/api/v1/watched-words/accounts/string/subscriptions' \
  -H 'Authorization: Bearer YOUR_TOKEN' \
  -H 'Content-Type: application/json' \
  --data-raw '{
  "url": "https://example.com"
}'
```

### JavaScript

```javascript
const body = `{
  "url": "https://example.com"
}`;

const response = await fetch('https://peertube2.cpy.re/api/v1/watched-words/accounts/string/subscriptions', {
  method: 'POST',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
    'Content-Type': 'application/json',
  },
  body,
});

const data = await response.text();
```

### Python

```python
import requests

body = '''{
  "url": "https://example.com"
}'''

response = requests.post(
    'https://peertube2.cpy.re/api/v1/watched-words/accounts/string/subscriptions',
    data=body.encode('utf-8'),
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
        'Content-Type': 'application/json',
    },
)
print(response.text)
```


## Delete account watched words subscription

`DELETE /api/v1/watched-words/accounts/{accountName}/subscriptions/{id}`

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": []
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started


Parameters:

- `accountName` (path, string, required)
  Type: string

- `id` (path, integer, required)
  Type: integer

Responses:

- 204: successful operation

- 404: watched words subscription does not exist

## Examples

### cURL

```bash
curl -X DELETE 'https://peertube2.cpy.re/api/v1/watched-words/accounts/string/subscriptions/0' \
  -H 'Authorization: Bearer YOUR_TOKEN'
```

### JavaScript

```javascript
const response = await fetch('https://peertube2.cpy.re/api/v1/watched-words/accounts/string/subscriptions/0', {
  method: 'DELETE',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
  },
});

const data = await response.text();
```

### Python

```python
import requests

response = requests.delete(
    'https://peertube2.cpy.re/api/v1/watched-words/accounts/string/subscriptions/0',
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
    },
)
print(response.text)
```


## List server watched words subscriptions

`GET /api/v1/watched-words/server/subscriptions`

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": [
      "admin",
      "moderator"
    ]
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started
; scopes: admin, moderator

Parameters:

- `start` (query, integer, optional) - Offset used to paginate results
  Type: integer
  
  minimum: 0

- `count` (query, integer, optional) - Number of items to return
  Type: integer
  
  default: 15
  
  minimum: 1
  
  maximum: 100

- `sort` (query, string, optional) - Sort column
  Type: string
  
  Example:
  
  ```json
  "-createdAt"
  ```

- `search` (query, string, optional) - Plain text search, applied to various parts of the model depending on endpoint
  Type: string

Responses:

- 200: successful operation

Content type: application/json

Type: object

- `total` (optional)
  Type: integer
  
  Example:
  
  ```json
  1
  ```

- `data` (optional)
  Type: Array<WatchedWordsSubscription>
  
  Items:
    Reference: [WatchedWordsSubscription](https://docs.joinpeertube.org/api-rest-reference/api/models/watchedwordssubscription.md); Type: WatchedWordsSubscription

## Examples

### cURL

```bash
curl -X GET 'https://peertube2.cpy.re/api/v1/watched-words/server/subscriptions?count=15' \
  -H 'Authorization: Bearer YOUR_TOKEN'
```

### JavaScript

```javascript
const response = await fetch('https://peertube2.cpy.re/api/v1/watched-words/server/subscriptions?count=15', {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
  },
});

const data = await response.text();
```

### Python

```python
import requests

response = requests.get(
    'https://peertube2.cpy.re/api/v1/watched-words/server/subscriptions?count=15',
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
    },
)
print(response.text)
```


## Add server watched words subscription

`POST /api/v1/watched-words/server/subscriptions`

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": [
      "admin",
      "moderator"
    ]
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started
; scopes: admin, moderator

Request body: application/json

Type: object

- `url` (required)
  Type: string, url

Responses:

- 200: successful operation

Content type: application/json

Type: WatchedWordsSubscription

Schema: [WatchedWordsSubscription](https://docs.joinpeertube.org/api-rest-reference/api/models/watchedwordssubscription.md)

- `id` (optional)
  Reference: [id](https://docs.joinpeertube.org/api-rest-reference/api/models/id.md); Type: id
  
  minimum: 1
  
  Example:
  
  ```json
  42
  ```

- `name` (optional)
  Type: string

- `url` (optional)
  Type: string, url

- `importedWordsCount` (optional)
  Type: integer
  
  minimum: 0

- `lastSyncAt` (optional)
  Type: string, date-time; nullable
  
  Example:
  
  ```json
  "2021-05-04T08:01:01.502Z"
  ```

- `state` (optional)
  Type: object
  
  - `id` (optional)
    Type: integer
    
    enum: [1,2,3,4]
  
  - `label` (optional)
    Type: string

- `updatedAt` (optional)
  Type: string, date-time
  
  Example:
  
  ```json
  "2021-05-04T08:01:01.502Z"
  ```

- `createdAt` (optional)
  Type: string, date-time
  
  Example:
  
  ```json
  "2021-05-04T08:01:01.502Z"
  ```

- 400: cannot fetch or parse watched words URL

- 409: subscription already exists or watched words list with fetched name already exists

## Examples

### cURL

```bash
curl -X POST 'https://peertube2.cpy.re/api/v1/watched-words/server/subscriptions' \
  -H 'Authorization: Bearer YOUR_TOKEN' \
  -H 'Content-Type: application/json' \
  --data-raw '{
  "url": "https://example.com"
}'
```

### JavaScript

```javascript
const body = `{
  "url": "https://example.com"
}`;

const response = await fetch('https://peertube2.cpy.re/api/v1/watched-words/server/subscriptions', {
  method: 'POST',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
    'Content-Type': 'application/json',
  },
  body,
});

const data = await response.text();
```

### Python

```python
import requests

body = '''{
  "url": "https://example.com"
}'''

response = requests.post(
    'https://peertube2.cpy.re/api/v1/watched-words/server/subscriptions',
    data=body.encode('utf-8'),
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
        'Content-Type': 'application/json',
    },
)
print(response.text)
```


## Delete server watched words subscription

`DELETE /api/v1/watched-words/server/subscriptions/{id}`

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": [
      "admin",
      "moderator"
    ]
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started
; scopes: admin, moderator

Parameters:

- `id` (path, integer, required)
  Type: integer

Responses:

- 204: successful operation

- 404: watched words subscription does not exist

## Examples

### cURL

```bash
curl -X DELETE 'https://peertube2.cpy.re/api/v1/watched-words/server/subscriptions/0' \
  -H 'Authorization: Bearer YOUR_TOKEN'
```

### JavaScript

```javascript
const response = await fetch('https://peertube2.cpy.re/api/v1/watched-words/server/subscriptions/0', {
  method: 'DELETE',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
  },
});

const data = await response.text();
```

### Python

```python
import requests

response = requests.delete(
    'https://peertube2.cpy.re/api/v1/watched-words/server/subscriptions/0',
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
    },
)
print(response.text)
```
